#include "stdafx.h"
#include <iostream>
#include <d3d9.h>
#include "D3DDevice.h"
#include "Log.h"

using namespace std;

int D3DDevice::BACK_BUFFER_SIZE = 128;

D3DDevice::D3DDevice(HWND hwnd, BOOL window)
{
	IDirect3D9 *temp_d3d = NULL;
	if ((temp_d3d = Direct3DCreate9(D3D_SDK_VERSION)) == NULL){
		Log::Add("D3DDevice::Initialize() : Direct3D̍쐬Ɏs");
		return;
	}
	m_pD3D = boost::intrusive_ptr<IDirect3D9>(temp_d3d, false);
	temp_d3d = NULL;

	D3DDISPLAYMODE d3ddm;
	if(FAILED(m_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm))){
		Log::Add("D3DDevice::Initialize() : fBXvC[h擾ł܂ł");
		return;
	}

	D3DPRESENT_PARAMETERS d3dpp = {0};
	d3dpp.Windowed = window;
	d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	d3dpp.BackBufferCount = 0;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
    d3dpp.EnableAutoDepthStencil = FALSE;
	d3dpp.BackBufferWidth = BACK_BUFFER_SIZE;
	d3dpp.BackBufferHeight = BACK_BUFFER_SIZE;
/*
	D3DFORMAT iAutoDepthStencilFormat[] = {D3DFMT_D24X8, D3DFMT_D16, D3DFMT_D32, D3DFMT_UNKNOWN};
	for (int i = 0; i < sizeof(iAutoDepthStencilFormat) / sizeof(D3DFORMAT); ++i){
		d3dpp.AutoDepthStencilFormat = iAutoDepthStencilFormat[i];
		if (FAILED(m_pD3D->CheckDepthStencilMatch(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, d3ddm.Format, d3dpp.BackBufferFormat, d3dpp.AutoDepthStencilFormat))){
			continue;
		}
		break;
	}
*/
	IDirect3DDevice9 *temp_device = NULL;
	if(FAILED(m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hwnd, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &d3dpp, &temp_device))){
		Log::Add("D3DDevice::Initialize() : n[hEFA_gpł܂ł");

		if(FAILED(m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hwnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &d3dpp, &temp_device))){
			Log::Add("D3DDevice::Initialize() : \tgEFA_gpł܂ł");

			if(FAILED(m_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hwnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &d3dpp, &temp_device))){
				Log::Add("D3DDevice::Initialize() : t@XX^CU[hgpł܂ł");

				return;
			}
		}
	}
	Log::Add("D3DDevice::Initialize() : DirectX̏ɐ܂");

	m_pDevice = boost::intrusive_ptr<IDirect3DDevice9>(temp_device, false);
	temp_device = NULL;

	return;
}

D3DDevice::~D3DDevice()
{
	m_pDevice = NULL;
	m_pD3D = NULL;
}

IDirect3DDevice9* D3DDevice::GetDevice()
{
	return m_pDevice.get();
}
