#ifndef INTERNET_FILE_H
#define INTERNET_FILE_H

#include <string>
#include <memory>

class CHttpConnection;
class CHttpFile;
class CInternetSession;
class NKFWrapper;

class InternetFile
{
private:
	CHttpConnection* m_pServer;
	CHttpFile* m_pFile;
	bool m_bIsOpened;
	static const int HTTP_BUFFER_SIZE;
	std::auto_ptr<NKFWrapper> m_pNKF;
public:
	InternetFile(CInternetSession* session, const std::string& url);
	virtual ~InternetFile();
	bool ReadString(std::string& s);
	int Read(void* buffer, int size);
	bool IsOpened()const{return m_bIsOpened;}
	const std::string GetFileName()const;
};


#endif
