#include "stdafx.h"
#include <string>
#include <sstream>
#include <afxinet.h>
#include "InternetSession.h"
#include "Log.h"

using namespace std;

InternetSession::InternetSession(const string& name) : m_pInternetSession(NULL)
{
	m_pInternetSession = new CInternetSession(name.c_str());
	if (!m_pInternetSession){
		Log::Add("InternetSession::InternetSession() : C^[lbgZbV̍쐬Ɏs܂");
	}
}

InternetSession::~InternetSession()
{
	if (m_pInternetSession){
		delete m_pInternetSession;
		m_pInternetSession = NULL;
	}
}

CInternetSession* InternetSession::GetSession()const
{
	return m_pInternetSession;
}

void InternetSession::ClearProxy()
{
	INTERNET_PROXY_INFO info = {0};
	info.dwAccessType = INTERNET_OPEN_TYPE_DIRECT;
}

void InternetSession::SetProxy(const std::string& server, int port)
{
	INTERNET_PROXY_INFO info = {0};
	info.dwAccessType = INTERNET_OPEN_TYPE_PROXY;

	ostringstream oss;
	oss << server << ":" << port;
	m_strProxy = oss.str();

	info.lpszProxy = m_strProxy.c_str();

	m_pInternetSession->SetOption(INTERNET_OPTION_PROXY, &info, sizeof(info));
}
