#include "stdafx.h"
#include <iostream>
#include <cstdio>
#include <sstream>
#include "Log.h"
#include "Utility.h"

using namespace std;

std::ofstream Log::m_ofs;
//FILE *Log::m_pFile = NULL;

void Log::Start(const std::string& file_name)
{
	//SetCurrentDirectory(Utility::GetProgramFolder().c_str());

	if (m_ofs.is_open()){
		m_ofs.close();
	}
	m_ofs.open(file_name.c_str(), ios_base::out | ios_base::app);

	//if (m_pFile){
	//	fclose(m_pFile);
	//	m_pFile = NULL;
	//}
	//m_pFile = fopen(file_name.c_str(), "at");
}

void Log::Stop()
{
	m_ofs.close();
	//fclose(m_pFile);
	//m_pFile = NULL;
}

void Log::Add(const std::string& text, bool add_time)
{
	string format_text = text;
	size_t index;

	while ((index = format_text.find("\r\n")) != string::npos){
		format_text.replace(index, 2, " ");
	}
	while ((index = format_text.find("\n")) != string::npos){
		format_text.replace(index, 1, " ");
	}

	time_t t = time(NULL);
	ostringstream oss;
	if (add_time){
		oss << CTime::GetCurrentTime().Format("%y/%m/%d %H:%M:%S - ");
		//oss << COleDateTime::GetCurrentTime().Format() << " - ";
	}
	oss << format_text;
	//oss << ctime(&t) << " - " << format_text << endl;

	fprintf(stderr, "%s\n", oss.str().c_str());

	//cerr << oss.str() << endl;

	//cerr << oss.str() << endl;
	m_ofs << oss.str() << endl;

	//if (m_pFile){
	//	fputs(oss.str().c_str(), m_pFile);
	//}
}

void Log::LastError(DWORD e)
{
	LPVOID lpMsgBuf = 0;
	if (!FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL)){
		LPVOID lpMsgBuf2 = 0;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
#ifdef _DEBUG
//		AfxMessageBox((char*)lpMsgBuf2);
#endif
	}
	Add((LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}
