#include "stdafx.h"
#include "NFileInternet.h"
#include "Utility.h"

using namespace std;

NFileInternet::NFileInternet(const std::string& url)
{
	m_bIsOpen = false;
	CStdioFile *file_from = m_Session.OpenURL(url.c_str());
	if (file_from == NULL){
		return;
	}
	m_bIsOpen = true;
	m_pFile = auto_ptr<CStdioFile>(file_from);
}

NFileInternet::~NFileInternet()
{
	Close();
}

bool NFileInternet::IsOpen()const
{
	return m_bIsOpen;
}

void NFileInternet::Close()
{
	if (m_bIsOpen){
		auto_ptr<CStdioFile> file = m_pFile;
		m_Session.Close();
		m_bIsOpen = false;
	}
}

int NFileInternet::Read(void* buffer, int size)
{
	return (int)m_pFile->Read(buffer, size);
}

int NFileInternet::Write(const void* buffer, int size)
{
	return 0;
}

void NFileInternet::Seek(long long size, int base)
{
	return;
}

void NFileInternet::SetBuffer(int size)
{
	return;
}

long long NFileInternet::GetSize()
{
	return (long long)m_pFile->GetLength();
}
