#ifndef NFILESTDIO_H
#define NFILESTDIO_H

#include <string>
#include <cstdio>
#include <memory>
#include "NFile.h"

class NFileStdio : public NFile{
private:
	FILE *m_pFile;
	std::auto_ptr<char> m_pBuffer;
	const std::string m_strFilePath;
public:
	NFileStdio(const std::string& file_path, const std::string& mode);
	virtual ~NFileStdio();
	virtual bool IsOpen()const;
	virtual void Close();
	virtual int Read(void* buffer, int size);
	virtual int Write(const void* buffer, int size);
	virtual void Seek(long long size, int base);
	virtual void SetBuffer(int size);
	virtual long long GetSize();
	virtual void Flush();
};

#endif
