#ifndef NKF_WRAPPER_H
#define NKF_WRAPPER_H

#include <memory>

class CMutex;

class NKFWrapper
{
public:
	NKFWrapper();
	virtual ~NKFWrapper();
	bool SetOption(const std::string& option);
	bool Convert(std::string& s);
private:
	typedef int (CALLBACK* FuncPtrSetNkfOption)(LPCSTR optStr);
	typedef BOOL (CALLBACK* FuncPtrNkfConvertSafe)(LPSTR outStr,DWORD nOutBufferLength,LPDWORD lpBytesReturned, LPCSTR inStr,DWORD nInBufferLength);

	FuncPtrSetNkfOption SetNkfOption;
	FuncPtrNkfConvertSafe NkfConvertSafe;

	HMODULE m_hModule;
	static std::auto_ptr<CMutex> m_pMutex;
};

#endif
