#ifndef SQLITE_H
#define SQLITE_H

#include <string>

//http://lcl.web5.jp/prog/pmemo/sqlite3dll.html
//Rsy

struct sqlite3;

class SQLite
{
private:
	typedef int (*sqlite3_callback)(void*,int,char**, char**);
	typedef int (__cdecl * pOpen)(char *, sqlite3 **);
	typedef int (__cdecl * pExec)(sqlite3 *, const char *, sqlite3_callback, void *, char **);
	typedef int (__cdecl * pGetTable)(sqlite3 *, const char *, char ***, int *, int *, char **);
	typedef int (__cdecl * pFreeTable)(char **);
	typedef int (__cdecl * pClose)(sqlite3 *);
	typedef int (__cdecl * pFree)(char *);

	pOpen sqlite3_open;
	pExec sqlite3_exec;
	pGetTable sqlite3_get_table;
	pFreeTable sqlite3_free_table;
	pClose sqlite3_close;
	pFree sqlite3_free;

	void LoadDll();
	void FreeDll();

	HINSTANCE m_hDll;
	sqlite3 *m_pDataBase;
	std::string m_strError;

public:
	SQLite();
	SQLite(const std::string& data_base_file_path);
	virtual ~SQLite();
	int Open(const std::string& data_base_file_path);
	int Exec(const std::string& sql, sqlite3_callback callback, void* param);
	int GetTable(const std::string& sql, char **&table, int &row, int &column);
	int FreeTable(char **&table);
	int Close();
	const std::string& GetError()const;
};

#endif
