#ifndef THREAD_POOL_H
#define THREAD_POOL_H

#include <set>
#include <boost/shared_ptr.hpp>
#include <atlutil.h>

//class CThreadPool;
class ThreadPoolWorkerBase;
class Worker;
class CCriticalSection;

class ThreadPool
{
private:
	class Worker
	{
	public:
		typedef ThreadPoolWorkerBase* RequestType;
		BOOL Initialize(void* pvWorkerParam);
		void Execute(RequestType request, void* pvWorkerParam, OVERLAPPED* pOverlapped);
		void Terminate(void* pvWorkerParam);
	};

	std::auto_ptr<CThreadPool<Worker> > m_pThreadPool;
	HANDLE m_hSignal;
	int m_iThreadCount;
	std::auto_ptr<CCriticalSection> m_pCriticalSection;
public:
	ThreadPool(int pool_size = 0);
	virtual ~ThreadPool();
	bool Add(ThreadPoolWorkerBase* worker);
	void WaitFinish();

	void IncCount();
	void DecCount();
	int GetThreadCount();
};

#endif
