#ifndef BINARY_H
#define BINARY_H

#include <stdio.h>

int read_le_int16(FILE *in, short *out);
int read_le_int32(FILE *in, int *out);
int write_le_int16(short in, FILE *out);
int write_le_int32(int in, FILE *out);

int read_be_int16(FILE *in, short *out);
int read_be_int32(FILE *in, int *out);
int write_be_int16(short in, FILE *out);
int write_be_int32(int in, FILE *out);

int le_char_array_to_int32(char *in);
short le_char_array_to_int16(char *in);
void int32_to_le_char_array(int in, char *out);
void int16_to_le_char_array(short in, char *out);

int be_char_array_to_int32(char *in);
short be_char_array_to_int16(char *in);
void int32_to_be_char_array(int in, char *out);
void int16_to_be_char_array(short in, char *out);
	
int binary_to_4bit_decimal(unsigned char hex);

void print_bit(int data, int column, FILE *out);

void file_skip(FILE *stream, size_t skip_size);

size_t get_filesize(char *filepath);	

#endif
