#include "stdafx.h"
#include "GameData.h"
#include "ThreadPool.h"
#include "SettingFile.h"
#include "GameDataWorker.h"

using namespace std;

const string SOFT_DATA_FILE_NAME = "softdata.ini";

GameData::GameData(Control& control) : m_Control(control)
{
	m_pThreadPool = auto_ptr<ThreadPool>(new ThreadPool(1));

	m_pDataBase = std::auto_ptr<SettingFile>(new SettingFile());
	m_pDataBase->Load(SOFT_DATA_FILE_NAME);
}

GameData::~GameData()
{
	m_pDataBase->Save(SOFT_DATA_FILE_NAME);
}

void GameData::Show(const std::string& directory_name)
{
	m_pThreadPool->Add(new GameDataWorker(m_Control, directory_name, *this));
}
