#ifndef GAME_DATA_H
#define GAME_DATA_H

#include <memory>
#include <string>

class ThreadPool;
class SettingFile;
class Control;

class GameData
{
private:
	Control& m_Control;
	std::auto_ptr<ThreadPool> m_pThreadPool;
	std::auto_ptr<SettingFile> m_pDataBase;
public:
	GameData(Control& control);
	virtual ~GameData();
	void Show(const std::string& directory_name);
	SettingFile& GetDataBase()const{return *m_pDataBase;}
};

#endif
