#ifndef GAME_TITLE_GETTER_H
#define GAME_TITLE_GETTER_H

#include <string>
#include "ThreadPoolWorkerBase.h"

class GameData;
class InternetFile;
class Control;

class GameDataWorker : public ThreadPoolWorkerBase
{
private:
	std::string m_strProductID;
	GameData& m_GameData;
	Control& m_Control;

	void FromLocal()const;
	void FromInternet()const;
	void ShowGameData(const std::string& text)const;
	bool SkipHtml(const std::string& target, InternetFile& file, int additional_line = 0)const;
	bool GetNextString(InternetFile& file, std::string& res)const;
	const std::string& EraseTag(std::string& s)const;
public:
	GameDataWorker(Control& control, const std::string& directory, GameData& game_data);
	virtual ~GameDataWorker();
	virtual void Run();
};

#endif
