#ifndef ICON_OBJECT_PS1_H
#define ICON_OBJECT_PS1_H

#include <string>
#include <boost/intrusive_ptr.hpp>
#include <d3dx9math.h>
#include "IconObjectBase.h"

struct IDirect3DDevice9;

class IconObjectPS1 : public IconObjectBase
{
public:
	struct VERTEX{
		D3DXVECTOR3 p;
		D3DXVECTOR2 t;
	};
private:
	static const VERTEX BILLBOARD[];
	static const DWORD FVF;
	std::vector<boost::intrusive_ptr<IDirect3DTexture9> > m_vecTexture;
	int m_iTime;
public:
	IconObjectPS1(IDirect3DDevice9 *device, const std::string& file_path);
	virtual ~IconObjectPS1();
	virtual void Update(int time);
	virtual void Draw()const;
};

#endif
