#ifndef ICON_OBJECT_PS2_H
#define ICON_OBJECT_PS2_H

#include <memory>
#include <string>
#include <vector>
#include <boost/intrusive_ptr.hpp>
#include "IconObjectBase.h"

class IconFile;
class VertexBuffer;

class IconObjectPS2 : public IconObjectBase
{
public:
	struct VERTEX{
		D3DXVECTOR3 p;
		D3DXVECTOR3 n;
		D3DCOLOR c;
		D3DXVECTOR2 t;
		VERTEX(const D3DXVECTOR3& pos, const D3DXVECTOR3& normal, const D3DXVECTOR2& texture, D3DCOLOR color) :
		p(pos), n(normal), t(texture), c(color){}
	};
	static const DWORD FVF;

private:
	std::auto_ptr<IconFile> m_pIconFile;
	boost::intrusive_ptr<IDirect3DTexture9> m_pTexture;
	std::auto_ptr<VertexBuffer> m_pVertexBuffer;

	bool m_bIsOpened;
	int m_iTime;
public:
	IconObjectPS2(IDirect3DDevice9* device, const std::string& icon_sys_file_path);
	virtual ~IconObjectPS2();
	virtual void Update(int time);
	virtual void Draw()const;
};

#endif
