#ifndef ICON_TEXTURE_H
#define ICON_TEXTURE_H

#include <string>
#include <vector>
#include <boost/intrusive_ptr.hpp>

struct IDirect3DTexture9;
struct IDirect3DDevice9;

//eNX`f[^ێNX
//32bitJ[̂
class IconTexture
{
private:
	IDirect3DDevice9 *m_pDevice;
	boost::intrusive_ptr<IDirect3DTexture9> m_pTexture;
	int m_iHeight;
	int m_iWidth;
public:
	IconTexture(IDirect3DDevice9 *device);
	IconTexture(IDirect3DDevice9 *device, const std::string& file_path);
	IconTexture(IDirect3DDevice9 *device, const std::vector<char>& pixel, int height, int width);
	virtual ~IconTexture();

	void Load(const std::string& file_path);
	void Save(const std::string& file_path)const;

	const boost::intrusive_ptr<IDirect3DTexture9>& GetTexture(){return m_pTexture;}
	int GetHeight()const{return m_iHeight;}
	int GetWidth()const{return m_iWidth;}
};

#endif
