#ifndef MEMORY_CARD_BASE_H
#define MEMORY_CARD_BASE_H

#include <string>
#include <vector>

class Control;

class MemoryCard
{
protected:
	Control& m_Control;
	int m_iValidMemoryCardSlot;

	MemoryCard(Control& control) : m_Control(control), m_iValidMemoryCardSlot(0){}
	virtual ~MemoryCard(){}
public:
	struct FILE_DATA{
		bool is_directory;
		char permission[3];
		int file_size;
		CTime time;
		std::string name;
		void SetFtpListLine(const std::string& ftp_list_line);
		void SetPS2ClientListLine(const std::string& ps2client_list_line);
		void SetPermissionString(const std::string& str);
	private:
		int Clamp(int lower, int upper, int val);
	};
	virtual bool IsConnecting() = 0;
	int EnumerateMemoryCardSlot(){return m_iValidMemoryCardSlot;}
	virtual bool ChangeDirectory(const std::string& directory_name) = 0;
	virtual const std::vector<MemoryCard::FILE_DATA> List() = 0;
	virtual bool Remove(const std::string& file_name) = 0;
	virtual bool Put(const std::string& file_name) = 0;
	virtual bool Get(const std::string& file_name) = 0;
	virtual bool RemoveDirectory(const std::string& directory_name) = 0;
	virtual bool MakeDirectory(const std::string& directory_name) = 0;
};

#endif
