#include "stdafx.h"
#include "MemoryCardFactory.h"
#include "MemoryCardFtp.h"
#include "MemoryCardNull.h"
#include "MemoryCardPS2Link.h"
#include "MemoryCardUSBMemory.h"

using namespace std;

boost::shared_ptr<MemoryCard> MemoryCardFactory::GetMemoryCard(Control& control, int type, const std::string& address)
{
	if (type == CONNECTION_TYPE_FTP){
		return boost::shared_ptr<MemoryCardFtp>(new MemoryCardFtp(control, address));
	} else if (type == CONNECTION_TYPE_PS2LINK){
		return boost::shared_ptr<MemoryCardPS2Link>(new MemoryCardPS2Link(control, address));
	} else if (type == CONNECTION_TYPE_USB_MEMORY){
		return boost::shared_ptr<MemoryCardUSBMemory>(new MemoryCardUSBMemory(control));
	}
	return boost::shared_ptr<MemoryCardNull>(new MemoryCardNull(control));
}

boost::shared_ptr<MemoryCard> MemoryCardFactory::GetNullMemoryCard(Control& control)
{
	return boost::shared_ptr<MemoryCardNull>(new MemoryCardNull(control));
}
