#ifndef MEMORY_CARD_FTP_H
#define MEMORY_CARD_FTP_H

#include "MemoryCard.h"

class CFtpConnection;

class MemoryCardFtp : public MemoryCard
{
private:
	CFtpConnection* m_pFtpConnection;
	std::string m_strCurrectDirectory;
	std::string m_strURLPrefix;

	void SleepFtp(int ms);
	bool MustSleep();
public:
	MemoryCardFtp(Control& control, const std::string& server_address);
	virtual ~MemoryCardFtp();
	virtual bool IsConnecting();
	virtual bool ChangeDirectory(const std::string& directory_name);
	virtual const std::vector<MemoryCard::FILE_DATA> List();
	virtual bool Remove(const std::string& file_name);
	virtual bool Put(const std::string& file_name);
	virtual bool Get(const std::string& file_name);
	virtual bool RemoveDirectory(const std::string& directory_name);
	virtual bool MakeDirectory(const std::string& directory_name);
};

#endif
