#ifndef PS1_SAVE_FILE_MCR_H
#define PS1_SAVE_FILE_MCR_H

#include <vector>
#include <utility>
#include <string>

class PS1SaveFileMcr
{
private:
	struct HEADER
	{
		char magic[2];
		char dummy[125];
		char xor[1];
		HEADER();
	};

	struct SOFT_HEADER
	{
		char flag[1];
		char dummy1[3];
		char block[4];
		char link[2];
		char name[117];
		char xor[1];
		SOFT_HEADER();
		SOFT_HEADER(int flag, int block, int link, const std::string& id);
	};

	static char CalcXor(const char *ptr);

	std::vector<std::pair<std::string, std::vector<char> > > m_vecData;
	int m_iUsedBlock;
public:
	PS1SaveFileMcr();
	virtual ~PS1SaveFileMcr();
	bool LoadRaw(const std::string& file_path);
	bool SaveRaw(const std::string& directory_path)const;//t@C֕ۑ
	bool Load(const std::string& file_path);
	bool Save(const std::string& file_path)const;
};

#endif
