#ifndef VERTEX_BUFFER_H
#define VERTEX_BUFFER_H

#include <d3d9types.h>
#include <boost/intrusive_ptr.hpp>

struct IDirect3DVertexDeclaration9;
struct IDirect3DVertexBuffer9;

class VertexBuffer
{
private:
	static const DWORD ICON_FVF;
	boost::intrusive_ptr<IDirect3DVertexBuffer9> m_pVertexBuffer;
	IDirect3DDevice9 *m_pDevice;

	int m_iOffsetBegin;//oCgP
	int m_iOffsetEnd;//oCgP
	int m_iBufferSize;
public:
	VertexBuffer(IDirect3DDevice9 *device, int buffer_size);
	virtual ~VertexBuffer();
	void* Lock(int vertex_count);
	void Unlock();
	void Draw()const;
};

#endif
